SystemOrganization addCategory: #'Xtreams-HttpTests'!

TestCase subclass: #XTChunkingReadStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-HttpTests'!

!XTChunkingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 16:00'!
testGrowing
	| actual stream |
	stream :=  #[51 13 10 97 98 99 13 10 53 13 10 100 101 102 103 104 13 10 48 13 10 13 10]
		reading chunking.
	actual := stream read: 8.
	self assert: actual = #[97 98 99 100 101 102 103 104]! !

!XTChunkingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 16:30'!
testHexLengths
	
	| actual stream |
	stream :=  #[70 13 10 97 98 99 100 101 102 103 104 105 
				  106 107 108 109 110 111 13 10 48 13 10 13 10] reading chunking.
	actual := stream rest.
	self assert: actual = #[97 98 99 100 101 102 103 104 105 106 107 108 109 110 111]! !

!XTChunkingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 16:10'!
testPartialChunk
	| actual stream |
	stream :=  #[51 13 10 97 98 99 13 10 50 13 10 100 101 13 10 48 13 10 13 10]
		reading chunking.
	stream read: 2.
	actual := stream read: 3.
	self assert: actual = #[99 100 101]! !

!XTChunkingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 16:09'!
testRest
	| actual stream |
	stream :=  #[51 13 10 97 98 99 13 10 50 13 10 100 101 13 10 48 13 10 13 10]
		reading chunking.
	actual := stream rest.
	self assert: actual = #[97 98 99 100 101]! !

!XTChunkingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 16:02'!
testShrinking
	| actual stream |
	stream :=  #[51 13 10 97 98 99 13 10 50 13 10 100 101 13 10 48 13 10 13 10]
		reading chunking.
	actual := stream read: 5.
	self assert: actual = #[97 98 99 100 101]! !

TestCase subclass: #XTChunkingWriteStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-HttpTests'!

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 18:42'!
chunk: aString
	| text |
	text := String new writing
		write: (aString size printStringBase: 16);
		cr;
		lf;
		write: aString;
		cr;
		lf;
		conclusion.
	^ text asByteArray! !

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 18:48'!
last: aString
	^ (self chunk: aString) , (self chunk: '')! !

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 21:22'!
testClose
	| compare stream |
	compare := (self last: 'abcdef') reading.
	stream := [ :byte | self assert: byte = compare get ] writing chunking.
	stream
		write: 'abc' asByteArray;
		write: 'def' asByteArray;
		close.
	self should: [ compare get ] raise: Incomplete! !

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/17/2011 22:15'!
testHexLengths
	| compare stream |
	compare := (self chunk: 'abcdefghijklmno') reading.
	stream := [:ch | self assert: ch = compare get] writing chunking.
	stream 
		write: 'abcdefghijklmno';
		flush.
	self should: [compare get] raise: Incomplete.
	! !

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/16/2011 09:27'!
testMultipleWrites
	| compare stream |
	compare := (self chunk: 'abcdef') reading.
	stream := [:ch | self assert: ch = compare get] writing chunking.
	stream 
		write: 'abc';
		write: 'def';
		flush.
	self should: [compare get] raise: Incomplete.
	! !

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 23:37'!
testOverflow
	| compare stream |
	compare := (self chunk: 'abcdef') reading.
	stream := [:byte | self assert: byte = compare get] writing chunking.
	stream bufferSize: 6.
	stream 
		write: 'abc';
		write: 'defghi'.
	self should: [compare get] raise: Incomplete.
	compare := (self chunk: 'ghi') reading.
	stream flush.
	self should: [compare get] raise: Incomplete.! !

!XTChunkingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/16/2011 01:07'!
testShortChunk
	| compare stream |
	compare := (self chunk: 'abc') reading.
	stream := [:ch | self assert: ch = compare get] writing chunking.
	stream 
		write: 'abc';
		flush.
	self should: [compare get] raise: Incomplete.
	! !

TestCase subclass: #XTHtmlEntityWriteStreamTest
	instanceVariableNames: 'out'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-HttpTests'!

!XTHtmlEntityWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2012 20:54'!
setUp
	out := String new writing entityEncoding! !

!XTHtmlEntityWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2012 20:55'!
testAmpersand
	out put: $&.
	self assert: out conclusion = '&amp;'! !

!XTHtmlEntityWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/11/2012 01:29'!
testAscii
	| ascii actual |
	ascii := '!!#$%''()*+,-./0123456789:;=?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~'.
	out write: ascii.
	actual := out conclusion.
	self assert: actual = ascii! !

!XTHtmlEntityWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2012 20:54'!
testCreation
	self assert: (out isKindOf: XTHtmlEntityWriteStream)! !

!XTHtmlEntityWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/11/2012 08:51'!
testEmbedded
	| actual |
	out write: 'abc&def'.
	actual := out conclusion.
	self assert: actual = 'abc&amp;def'! !

!XTHtmlEntityWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/11/2012 01:15'!
testGreaterThan
	| actual |
	out put: $>.
	actual := out conclusion.
	self assert: actual = '&gt;'! !

!XTHtmlEntityWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/11/2012 01:09'!
testLessThan
	| actual |
	out put: $<.
	actual := out conclusion.
	self assert: actual = '&lt;'! !

!XTHtmlEntityWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/11/2012 01:28'!
testQuote
	out put: $".
	self assert: out conclusion = '&quot;'! !

TestCase subclass: #XTHttpTokenStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-HttpTests'!

!XTHttpTokenStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2011 22:59'!
testContentType
	| in tokens |
	in := 'Content-Type: text/html; charset=UTF-8' reading httpTokenizing.
	tokens := in rest.
	self assert: tokens = #('Content-Type' ':' ' ' 'text' '/' 'html' ';' ' ' 'charset' '=' 'UTF-8')! !

!XTHttpTokenStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2011 22:58'!
testCrLf
	| in tokens |
	in := ('ABC', String crlf, 'DEF') reading httpTokenizing.
	tokens := in rest.
	self assert: tokens = {'ABC'. String crlf. 'DEF'}! !

!XTHttpTokenStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2011 15:48'!
testCreation
	| in |
	in := 'abc' reading httpTokenizing.
	self assert: (in isKindOf: XTHttpTokenStream)! !

!XTHttpTokenStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2011 22:59'!
testHeaderLine
	| in tokens |
	in := 'Content-Type: text/html; charset=UTF-8' reading httpTokenizing.
	tokens := in rest.
	self assert: tokens = #('Content-Type' ':' ' ' 'text' '/' 'html' ';' ' ' 'charset' '=' 'UTF-8')! !

!XTHttpTokenStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2011 22:59'!
testLinefolding
	| in tokens |
	in := ('ABC', String crlf, '  DEF') reading httpTokenizing.
	tokens := in rest.
	self assert: tokens = #('ABC' ' ' 'DEF')! !

!XTHttpTokenStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2011 23:00'!
testRequestLine
	| in tokens |
	in := 'GET / HTTP/1.1' reading httpTokenizing.
	tokens := in rest.
	self assert: tokens = #('GET' ' ' '/' ' ' 'HTTP' '/' '1.1')! !

!XTHttpTokenStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2011 23:01'!
testResponseLine
	| in tokens |
	in := 'HTTP/1.1 302 Found' reading httpTokenizing.
	tokens := in rest.
	self assert: tokens = #('HTTP' '/' '1.1' ' ' '302' ' ' 'Found')! !

!XTHttpTokenStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2011 23:02'!
testTrailingCrLf
	| in tokens |
	in := ('ABC', String crlf, String crlf) reading httpTokenizing.
	tokens := in rest.
	self assert: tokens = {'ABC'. String crlf. String crlf}! !

TestCase subclass: #XTPercentDecodingReadStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-HttpTests'!

!XTPercentDecodingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2012 15:52'!
testDoubleReserved
	| actual in |
	in := 'http://www.example.com' reading percentDecoding.
	actual := in rest.
	self assert: actual = #('http' $: $/ $/ 'www.example.com')
	! !

!XTPercentDecodingReadStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/24/2011 01:57'!
testSimple
	| actual in |
	in := 'abc=def&ghi=jkl' reading percentDecoding.
	actual := in rest.
	self assert: actual = #('abc' $= 'def' $& 'ghi' $= 'jkl').
	! !

TestCase subclass: #XTPercentEncodingWriteStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-HttpTests'!

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/24/2011 01:54'!
assert: ch isEncoded: encoded
	| out actual |
	out := String new writing percentEncoding.
	out put: ch.
	actual := out conclusion.
	self assert: actual first = $%.
	self assert: actual allButFirst = encoded! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/24/2011 01:54'!
assertIdentity: expected
	| out actual |
	out := String new writing percentEncoding.
	out write: expected.
	actual := out conclusion.
	self assert: actual = expected! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:17'!
testAmperstand
	self assert: $& isEncoded: '26'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:20'!
testAsterisk
	self assert: $* isEncoded: '2A'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:14'!
testBang
	self assert: $!!  isEncoded: '21'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:10'!
testColon
	self assert: $: isEncoded: '3A'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:21'!
testComma
	self assert: $, isEncoded: '2C'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 13:58'!
testDigits
	self assertIdentity: '0123456789'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:17'!
testDollar
	self assert: $$  isEncoded: '24'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:21'!
testEquals
	self assert: $= isEncoded: '3D'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:12'!
testHashMark
	self assert: $# isEncoded: '23'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:12'!
testLeftBracket
	self assert: $[ isEncoded: '5B'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:19'!
testLeftParen
	self assert: $( isEncoded: '28'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 13:59'!
testLowercase
	self assertIdentity: 'abcdefghijklmnopqrstuvwxyz'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:20'!
testPlus
	self assert: $+ isEncoded: '2B'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/24/2011 01:54'!
testPutThrough
	| out actual |
	out := String new writing percentEncoding.
	out putThrough: $&.
	actual := out conclusion.
	self assert: actual = '&'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:11'!
testQuestionMark
	self assert: $? isEncoded: '3F'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:13'!
testRightBracket
	self assert: $@ isEncoded: '40'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:20'!
testRightParen
	self assert: $) isEncoded: '29'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:21'!
testSemicolon
	self assert: $; isEncoded: '3B'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:18'!
testSingleQuote
	self assert: $' isEncoded: '27'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 15:11'!
testSlash
	self assert: $/ isEncoded: '2F'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 13:59'!
testUnreservedPunctuation
	self assertIdentity: '-._~'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/18/2011 13:59'!
testUppercase
	self assertIdentity: 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'! !

!XTPercentEncodingWriteStreamTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/24/2011 01:54'!
testWriteThrough
	| out actual |
	out := String new writing percentEncoding.
	out writeThrough: 'abc/def'.
	actual := out conclusion.
	self assert: actual = 'abc/def'! !
